/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */
package org.diacalc.mobile;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */

import com.sun.lwuit.*;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;
import com.sun.lwuit.events.FocusListener;
import com.sun.lwuit.layouts.BorderLayout;
import com.sun.lwuit.layouts.BoxLayout;
import com.sun.lwuit.layouts.GridLayout;
import com.sun.lwuit.layouts.GroupLayout;
import com.sun.lwuit.plaf.Border;
import com.sun.lwuit.plaf.UIManager;
import java.util.Date;
import java.util.Hashtable;
import java.util.Vector;
import javax.microedition.midlet.MIDlet;
import org.diacalc.mobile.components.*;
import org.diacalc.mobile.maths.*;
import org.diacalc.mobile.products.ProductGroup;
import org.diacalc.mobile.products.ProductInBase;
import org.diacalc.mobile.products.ProductInMenu;
import org.diacalc.mobile.products.ProductW;



public class MenuForm extends FormBase implements ActionListener{
     private static final int R_OLD_COMMAND = 20;
     private static final int R_ALL_COMMAND = 21;
     private static final int R_CURR_COMMAND = 22;
     private static final int N_PROD_COMMAND = 23;
     private static final int YES_COMMAND = 24;
     private static final int NO_COMMAND = 25;
     private static final int ROUND_DOSE_COMMAND = 26;
     private static final int RUN_TIMER_COMMAND = 27;
     private static final int ADD_EVENT_COMMAND = 28;
     
     private static final int IMPORT_MENU_COMMAND = 29;
     private static final int EXPORT_MENU_COMMAND= 30;
      

     private static final Command removeOldCommand = new Command("Убр. старые", R_OLD_COMMAND);
     private static final Command removeAllCommand = new Command("Очистить", R_ALL_COMMAND);
     private static final Command removeCurrCommand = new Command("Убр. прод.", R_CURR_COMMAND);
     private static final Command createProductCommand = new Command("Нов. прод.", N_PROD_COMMAND);
     private static final Command roundDoseCommand = new Command("Округл. дозу", ROUND_DOSE_COMMAND);
     private static final Command yesCommand = new Command("Да",YES_COMMAND);
     private static final Command noCommand = new Command("Нет",NO_COMMAND);
     private static final Command runTimerCommand = new Command("Таймер",RUN_TIMER_COMMAND);
     private static final Command addEventCommand = new Command("Доб. запись",ADD_EVENT_COMMAND);
     
     private static final Command importMenuCommand = new Command("Импорт",IMPORT_MENU_COMMAND);
     private static final Command exportMenuCommand = new Command("Экспорт",EXPORT_MENU_COMMAND);
     
    private Label fldBD;
    private Label fldMD;
    private Label fldSUM;
    private Label fldInfo;

    private MaskTextField fldK1;
    private MaskTextField fldK2;
    private MaskTextField fldBE;
    private TextField fldS1;
    private TextField fldS2;
    private TextField fldOUV;

    
    private Container rowPane;

    private Container coefPane,ouvPane;
    private Container middle = null;
    
    
    private DCJmobile master;

    private Vector rows = null;
    
    private NumbersKeyboard vk;
    private NumbersKeyboard vkS;
    private NumbersKeyboard vkCoef;
    
    //private boolean fldSugarsHaveChanged = false;

    /*private ActionListener menuCalculator = new ActionListener(){
        public void actionPerformed(ActionEvent ev){
            System.out.println("menu calulator");
            //тут нужно  выводить сообщение о слишком большой разнице ск1 и ск2
            if ((ev.getSource()==fldS1 || ev.getSource()==fldS2) && fldSugarsHaveChanged){
                checkSugarDifference();
                fldSugarsHaveChanged = false;
            }
            calcMenu();
        }
    };*/

    public String getName() {
        return "Меню";
    }
    public String getIconName(){
        return "menu";
    }
    private void checkSugarDifference(){
        Sugar s1 = new Sugar();
        s1.setSugar(Str.parseString(fldS1, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        master.getUser().setS1(s1.getValue());
        Sugar s2 = new Sugar();
        s2.setSugar(Str.parseString(fldS2, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        master.getUser().setS2(s2.getValue());
        if ( (master.getUser().getS1()-master.getUser().getS2())>5.01f ){
            Sugar s3 = new Sugar(master.getUser().getS1()-5);
            TextArea txt = new TextArea("Не рекомендуется резко снижать СК!\n"
                    + "Рекомендуемый целевой СК " +
                    Str.round(s3.getSugar(master.getUser().isMmol(),
                        master.getUser().isPlasma()),1) +
                    "\nИзменить?");
            txt.setEditable(false);
            if (Dialog.show("Предупреждение",
                    txt,
                    new Command[]{yesCommand,noCommand},
                    Dialog.TYPE_WARNING,
                    null).getId()==YES_COMMAND){
                master.getUser().setS2(s3.getValue());
                //тут устнавливаем, что бы не зациклить проверку
                //иначе проверка может быть бесконечной
                fldS2.setText(""+Str.round(s3.getSugar(master.getUser().isMmol(),
                        master.getUser().isPlasma()),1));

            }
        }
    }
    private ContextMenu contextMenu = new ContextMenu();
    
    private Container topPane;
    
    protected void execute(MIDlet m,boolean refresh) {
        if (contextMenu.getCommandsSize()==0){
            contextMenu.addCommand(roundDoseCommand,this);
            contextMenu.addCommand(removeCurrCommand,this);
        }
        if (refresh){
            vk = new NumbersKeyboard();
            vkS = new NumbersKeyboard();
            vkCoef = new NumbersKeyboard();
            
            vk.addCloseListener(new CloseListener() {
                public void wasClosed() {
                    calcMenu();
                    //Тут должны перевести фокус на след элемент.
                    if (!rows.isEmpty()){
                        int sel = -1;
                        for(int i=0;i<rows.size();i++){
                            if ( ((ProdRow)rows.elementAt(i)).weight.hasFocus() ){
                                sel = i;
                                break;
                            }
                        }
                        if (sel>-1 && sel<(rows.size()-1)){//Если sel было выбрано и меньше последнего элемента, то переводим фокус
                            ((ProdRow)rows.elementAt(sel+1)).weight.requestFocus();
                        }
                    }
                }
            });
            vkCoef.addCloseListener(new CloseListener() {
                public void wasClosed() {
                    calcMenu();
                }
            });
            vkS.addCloseListener(new CloseListener() {
                public void wasClosed() {
                    //тут проверяем сахара
                    checkSugarDifference();
                    calcMenu();
                }
            });
            
            
            rows = new Vector();
            master = (DCJmobile)m;
            
            topPane = createTop();
            
            rowPane = new Container(new BoxLayout(BoxLayout.Y_AXIS));
            
            for(int i=0;i<master.getMenu().size();i++){
                addProductToRow( (ProductInMenu)master.getMenu().elementAt(i) );
            }

            coefPane  = createCoefPane();
            ouvPane  = createOUVPane();
            
            layoutComponents();
            
            fldK1.setValue( new Float(master.getUser().getFactors().getK1(Factors.DIRECT)) );
            fldK2.setValue( new Float( master.getUser().getFactors().getK2() ));
            fldBE.setValue( new Float( master.getUser().getFactors().getBE(Factors.DIRECT) ));

            form.addMenuCommand(addEventCommand,this);
            form.addMenuCommand(runTimerCommand,this);
            
            form.addMenuCommand(importMenuCommand,this);
            form.addMenuCommand(exportMenuCommand,this);
            
            form.addMenuCommand(createProductCommand,this);
            
            form.addMenuCommand(removeAllCommand,this);
            form.addMenuCommand(removeOldCommand,this);
            
            form.addRotationListener(rotationLsnr);
        }
        calcMenu();
    }
    private RotationListener rotationLsnr = new RotationListener() {
        public void rotationHappend() {
            layoutComponents();
        }
    };
    private Container leftLandscape = null;
    
    private void layoutComponents(){
        Container c = form.getContentPane();
        c.removeAll();
        if (leftLandscape!=null){
            leftLandscape.removeAll();
        }
        if (middle!=null){
            middle.removeAll();
        }
        
        if (Display.getInstance().isPortrait()){//Располагаем для портретной ориентации
            c.setLayout(new BorderLayout());
            
            c.addComponent(BorderLayout.NORTH, topPane);
            
            if (!coefPane.contains(ladderCoef)) coefPane.addComponent(BorderLayout.EAST, ladderCoef);
            if (!ouvPane.contains(ladderOUV)) ouvPane.addComponent(BorderLayout.WEST, ladderOUV);    
            /*}else{
                middle.removeAll();
            }*/
            middle = new Container(new BorderLayout());
            middle.setScrollableY(true);
            
            middle.addComponent(BorderLayout.CENTER, rowPane);
            middle.addComponent(BorderLayout.SOUTH, coefPane);
            
            //if (!c.contains(middle))
            c.addComponent(BorderLayout.CENTER, middle);
            c.setScrollableY(false);
        }else{
            c.setLayout(new BorderLayout());
            
            if (coefPane.contains(ladderCoef)) coefPane.removeComponent(ladderCoef);
            if (ouvPane.contains(ladderOUV))   ouvPane.removeComponent(ladderOUV);
            
            leftLandscape = new Container(new GridLayout(3,1));
            
            leftLandscape.addComponent(topPane);
            leftLandscape.addComponent(coefPane);
            leftLandscape.addComponent(ouvPane);
            
            middle = new Container(new BorderLayout());
            middle.setScrollableY(true);
            
            middle.addComponent(BorderLayout.CENTER, rowPane);
             
            middle.setPreferredW(Display.getInstance().getDisplayWidth()*56/100);
            leftLandscape.setPreferredW(Display.getInstance().getDisplayWidth()*44/100);
            
            c.addComponent(BorderLayout.CENTER, middle);
            c.addComponent(BorderLayout.EAST, leftLandscape);
        }
    }
    public void actionPerformed(ActionEvent ev){
        switch (ev.getCommand().getId()) {
            case R_OLD_COMMAND: removeOldEntries(); break;
            case R_ALL_COMMAND: removeAllEntries(); break;
            case R_CURR_COMMAND: removeCurrEntry(); break;
            case N_PROD_COMMAND: createProduct(); break;
            case ROUND_DOSE_COMMAND: roundDose(); break;
            case RUN_TIMER_COMMAND: runTimer(); break;
            case ADD_EVENT_COMMAND: addEvent(); break;
            case IMPORT_MENU_COMMAND: importMenu(); break;
            case EXPORT_MENU_COMMAND: exportMenu(); break;
        }
    }
    private void addProductToRow(ProductInMenu pr){
        ProdRow row = new ProdRow(contextMenu);
        row.name.setText( pr.getName() );
        row.setWeight( pr.getWeight());
        rows.addElement(row);
        rowPane.addComponent(row);
    }
    private void importMenu(){
        Hashtable ver_check = null;
        final InfoDialog infoDlg = new InfoDialog();
        Display.getInstance().callSeriallyAndWait(new Runnable(){
            public void run(){
                infoDlg.showModeless();
            }
        });
        //infoDlg.showModeless();
        //А сама загрузка должна быть в отдельном потоке
        Display.getInstance().invokeAndBlock(new Runnable() {
            public void run() {
                // perform IO operation..
                inetRequestResults = new DoingPOST(master.getUser()).receiveMenu();
            }
        });
        
        String response = (String)inetRequestResults.get(DoingPOST.ERROR);
        
        if (response.equals(DoingPOST.NO_ERROR)){
            //тут проверяем версию программы
            ver_check = new DoingPOST(master.getUser()).checkVersion();
        }
        
        
        Display.getInstance().callSeriallyAndWait(new Runnable(){
            public void run(){
                infoDlg.dispose();
            }
        });
        
        if (response.equals(DoingPOST.NO_ERROR)){
            //Все успешно, показываем поздравление
            Vector prods = (Vector)inetRequestResults.get(DoingPOST.MENU_MENU);
            int snacks = 0;
            for(int i=0;i<prods.size();i++){
                if ( ((ProductInMenu)prods.elementAt(i)).getId()==-11 ) snacks++;
            }
            TextArea txt = new TextArea("Меню загружено успешно\nТекущее меню будет заменено загруженным\n"+
                    (snacks>0?"Загруженное меню содержит перекус, его записи будут добавлены в общий список":"") );
            txt.setEditable(false);
            
            if (Dialog.show("Сообщение",
                txt,
                new Command[]{yesCommand,noCommand} ).getId()==YES_COMMAND){
                //Очищаем меню и заполняем новым
                master.getMenu().removeAllElements();
                rows.removeAllElements();
                rowPane.removeAll();
                
                removeAllEntries();
                for(int i=0;i<prods.size();i++){
                    //Тут добавляем перекус и устанавливаем им id = -1
                    ProductInMenu pr = (ProductInMenu)prods.elementAt(i);
                    pr.setId(-1);
                    master.getMenu().addElement( pr );
                    addProductToRow(pr);
                }
                User u = (User)inetRequestResults.get(DoingPOST.MENU_USER);
                
                fldK1.setValue( new Float( u.getFactors().getK1(Factors.DIRECT)) );
                fldK2.setValue( new Float( u.getFactors().getK2() ));
                fldBE.setValue( new Float( u.getFactors().getBE(Factors.DIRECT) ));
                
                fldS1.setText(""+Str.round(new Sugar(u.getS1())
                    .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
                fldS2.setText(""+Str.round(new Sugar(u.getS2())
                    .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
                
                fldOUV.setText(""+Str.round(
                    new Sugar(u.getFactors().getK3())
                        .getSugar(master.getUser().isMmol(),
                        master.getUser().isPlasma()),master.getUser().isMmol()?2:1));
                
                master.getUser().setS1(u.getS1());
                master.getUser().setS2(u.getS2());
                master.getUser().getFactors().setK3(u.getFactors().getK3());
                master.getUser().getFactors().setK2(u.getFactors().getK2());
                master.getUser().getFactors().setK1Value(u.getFactors().getK1Value());
                master.getUser().getFactors().setBEValue(u.getFactors().getBEValue());
                
                rowPane.revalidate();
                
                calcMenu();
            }
            VersionInfo.showVersionInfo(ver_check);
        }
        else{
            //произошла ошибка
            TextArea txt = new TextArea("При загрузке меню произошли ошибки\n"+
                    Str.replace(response,"<br>","\n"));
            txt.setEditable(false);
            Dialog.show("Ошибка",
                            txt,
                            new Command[] {new Command("Ok")},
                            Dialog.TYPE_ERROR,
                            null);
        }
        
    }
    private Hashtable inetRequestResults;
    
    private void exportMenu(){
        if (master.getMenu().isEmpty()) return;
        
        Hashtable ver_check = null;
        
        final InfoDialog infoDlg = new InfoDialog();
        Display.getInstance().callSeriallyAndWait(new Runnable(){
            public void run(){
                infoDlg.showModeless();
            }
        });
        //infoDlg.showModeless();
        //А сама загрузка должна быть в отдельном потоке
        Display.getInstance().invokeAndBlock(new Runnable() {
            public void run() {
                // perform IO operation..
                inetRequestResults = new DoingPOST(master.getUser()).sendMenu(master.getMenu());
            }
        });
        
        
        String response = (String)inetRequestResults.get(DoingPOST.ERROR);
        
        if (response.equals(DoingPOST.NO_ERROR)){
            //тут проверяем версию программы
            ver_check = new DoingPOST(master.getUser()).checkVersion();
        }
        
        Display.getInstance().callSeriallyAndWait(new Runnable(){
            public void run(){
                infoDlg.dispose();
            }
        });
        
        if (response.equals(DoingPOST.NO_ERROR)){
            //Все успешно, показываем поздравление
            TextArea txt = new TextArea("Меню выгружено на сервер успешно");
            txt.setEditable(false);
            Dialog.show("Сообщение",
                            txt,
                            new Command[] {new Command("Ok")},
                            Dialog.TYPE_INFO,
                            null);
            VersionInfo.showVersionInfo(ver_check);
        }
        else{
            //произошла ошибка
            TextArea txt = new TextArea("При выгрузке меню произошли ошибки\n"+
                    Str.replace(response,"<br>","\n"));
            txt.setEditable(false);
            Dialog.show("Ошибка",
                            txt,
                            new Command[] {new Command("Ok")},
                            Dialog.TYPE_ERROR,
                            null);
        }
    }
    //class ExportMenu
    private void addEvent(){
        if (master.getMenu().isEmpty()) return;
        ProductW pr = calcMenu();
        Sugar s1 = new Sugar(master.getUser().getS1());
        //s1.setSugar(Str.parseString(fldS1, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        Sugar s2 = new Sugar(master.getUser().getS2());
        //s2.setSugar(Str.parseString(fldS2, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        DPS dps = new DPS(s1,s2,master.getUser().getFactors());
        Dose ds = new Dose(pr,master.getUser().getFactors(),dps);
        
        long time = System.currentTimeMillis() + master.getUser().getTimeCorr()*1000*60*60;
        java.util.Calendar cal = java.util.Calendar.getInstance();
        cal.setTime(new Date(time));
        int hour = cal.get(java.util.Calendar.HOUR_OF_DAY);
        String cm;
        if (hour>=4 && hour<6) cm = "Ранний завтрак";
        else if (hour>=6 && hour<11) cm = "Завтрак";
        else if (hour>=11 && hour<14) cm = "Обед";
        else if (hour>=14 && hour<17) cm = "Ланч";
        else if (hour>=17 && hour<20) cm = "Ужин";
        else cm = "Поздний ужин";
        
        DiaryUnit du = new DiaryUnit(-1,
                time,
                cm,s1.getValue(),s2.getValue(),
                new Factors(master.getUser().getFactors()),
                ds.getWholeDose(),
                pr);

        Container c = new EventEditor(du,master.getUser());
        if (YES_COMMAND==Dialog.show("Новое событие",
                c,
                new Command[]{yesCommand,noCommand} ).getId()){
            DiaryUnit duR = ((EventEditor)c).getDiaryUnit();
            master.getDiary().addElement(duR);
            for(int i=0;i<master.getMenu().size();i++){
                ProductW prO = (ProductW)master.getMenu().elementAt(i);
                ProductInMenu prM = new ProductInMenu(
                            prO.getName(),
                            prO.getProt(),
                            prO.getFat(),
                            prO.getCarb(),
                            prO.getGi(),
                            prO.getWeight(),
                            -1);
                prM.setOwner(duR.getId());
                master.getDiaryRecs().addElement( prM );
            }
            master.shouldRefreshDiary();
            master.setNeedSaveDiary();
        }
    }
    private void runTimer(){
        Container c = new Container(new BoxLayout(BoxLayout.Y_AXIS));
        c.addComponent(new Label("Пауза"));
        

        MaskTextField intFld = new MaskTextField("##");

        VirtualKeyboard vkb = new NumbersKeyboard();
        VirtualKeyboard.bindVirtualKeyboard(intFld, vkb);
        
        intFld.setValue("30");
        c.addComponent(Str.createPair("минут:",intFld));
        CheckBox ch = new CheckBox("Уйти в фон");
        c.addComponent(ch);
        if (YES_COMMAND==Dialog.show("Таймер",
                c,
                new Command[]{yesCommand,noCommand} ).getId()){
            //тут нужно проверять на нулевое значение и в этом случае отменять запущенный таймер
            int delay;
            try{
                delay = Integer.parseInt( (String)intFld.getValue() );
            }catch (Exception ex){
                delay = 0;
            }
            if (delay==0) master.cancelAlarm();
            else{
                master.getUser().setTimerTime( System.currentTimeMillis() +
                        delay * 60 * 1000
                        );
                master.getUser().setMessage(
                        "БД:"+fldBD.getText() +
                        "\nМД:"+fldMD.getText() +
                        "\nВсего:"+fldSUM.getText());
                master.enableAlarm(ch.isSelected());
            }
        }
    }
    private void roundDose(){
        int pos = -1;
        for(int i=0;i<master.getMenu().size();i++){
            if ( ((ProdRow)rows.elementAt(i)).hasFocus() ){
                pos = i;
                break;
            }
        }
        if (pos>=0){
            //Пусть предел округления будет 0,5
            //float
            ProductW prod = (ProductInMenu)master.getMenu().elementAt(pos);//Выбранный продукт
            if (prod.getCarb()<2.0f){
                //Вывод сообщения о неимении смысла огруглять по этому продукту
                TextArea txt = new TextArea("У продукта "+ prod.getName()
                        + " слишком мало углеводов в составе.\n"
                        + "используйте продукт более богатый углеводами");
                txt.setEditable(false);
                Dialog.show("Округление",
                                txt,
                                new Command[] {new Command("Ok")},
                                Dialog.TYPE_INFO,
                                null);
                return;
            }
            ProductW sum = calcMenu();
            DPS dps = new DPS(
                    new Sugar(master.getUser().getS1()),
                    new Sugar(master.getUser().getS2()),
                    master.getUser().getFactors()
                    );
            Dose ds_now = new Dose(sum,master.getUser().getFactors(),
                    dps);
            ProductW prod100 = new ProductW(prod);
            prod100.setWeight(prod.getWeight()+100f);
            
            float dose_diff = new Dose(prod100,master.getUser().getFactors(),
                    dps).getWholeDose() - //тут величина ДПС не влияет
                        new Dose(prod,master.getUser().getFactors(),dps).getWholeDose();

            float frac = ds_now.getWholeDose() - 
                    (float)Math.floor(ds_now.getWholeDose());
            float step;
             switch (master.getUser().getRound()){
                case User.ROUND_1: step = 1f;
                                    break;
                case User.ROUND_05: step = 0.5f;
                                    break;
                case User.ROUND_025: step = 0.25f;
                                    break;
                case User.ROUND_010: step = 0.1f;
                                    break;
                case User.ROUND_005: step = 0.05f;
                                    break;
                default: step = 1;
             }
             float i = 0;
             while (i<frac)
                    i += step;
             float upDiff = (float)Math.floor( ds_now.getWholeDose() ) + i -
                     (float)ds_now.getWholeDose();
             float downDiff = ds_now.getWholeDose() -
                     (float)Math.floor( ds_now.getWholeDose() ) - (i-step);

             float wUp = upDiff * 100 / dose_diff;
             float wDown = downDiff * 100 / dose_diff;
             
             Label lblName = new Label(prod.getName());
             Label currW = new Label("Текущ. вес "+(int)Str.round(prod.getWeight(),0));
             Label lblDescr = new Label("Округл. до "+step);
             RadioButton rbUp = new RadioButton(" +" + Str.round(wUp,1) + " гр.");
             RadioButton rbDown = new RadioButton(" -" + Str.round(wDown,1) + " гр.");
             ButtonGroup gr = new ButtonGroup();
             gr.add(rbUp);
             gr.add(rbDown);
             rbUp.setSelected(true);
             Container c = new Container(new BoxLayout(BoxLayout.Y_AXIS));
             c.addComponent(lblName);
             c.addComponent(currW);
             c.addComponent(lblDescr);
             c.addComponent(rbUp);
             c.addComponent(rbDown);

             if (Dialog.show("Округление",
                c,
                new Command[]{yesCommand,noCommand} ).getId()==YES_COMMAND){
                 //Тут меняем
                 TextField wF = ((ProdRow)rows.elementAt(pos)).weight;
                 if (rbUp.isSelected()){
                     wF.setText( ""+ (Str.parseString(wF, 0) + wUp)  );
                 }
                 else{
                     wF.setText( ""+ (Str.parseString(wF, 0) - wDown)  );
                 }
                 calcMenu();
             }
         }
    }
    private void createProduct(){
        if (master.getMenu().isEmpty()) return;
        ProductInBase prod = new ProductInBase(calcMenu(),
                ((ProductGroup)master.getGroups().elementAt(0)).getId() );
        prod.setName("Новый продукт");
        ProductEditor c = new ProductEditor( prod ,master);

        int res = Dialog.show("Новый продукт",
                c,
                new Command[]{yesCommand,noCommand} ).getId();

        if (res==YES_COMMAND){
            prod = c.getProduct();
            prod.setWeight(100f);
            if (prod.getName().length()>0){//Начинаем изменять

                master.getProds().addElement(prod);

                Ordering.setSortField(Ordering.NAME_FIELD);
                Ordering.setSortType(Ordering.SORT_BY_ASC);
                Ordering.sort(master.getProds());

                master.shouldRefreshProductsForm();

                master.setNeedSaveBase();
            }
        }
    }
    private void removeOldEntries(){
        master.calcCoefsbyTime();
        boolean conj = false;//Есть ли чего удалять
        for(int i=master.getMenu().size();i>0;i--){
            if (
            ((ProductInMenu)master.getMenu().elementAt(i-1)).getId()<0){
                master.getMenu().removeElementAt(i-1);
                rowPane.removeComponent((Container)rows.elementAt(i-1));
                rows.removeElementAt(i-1);
                conj = true;
            }
        }
        if (conj){
            rowPane.revalidate();
            //middle.revalidate();
            if (master.getMenu().size()>0){
                ((ProdRow)rows.elementAt(0)).weight.requestFocus();
            }
            master.getUser().setS1( master.getUser().getTargetSugar() );
            master.getUser().setS2( master.getUser().getTargetSugar() );
            
            fldK1.setValue( new Float(master.getUser().getFactors().getK1(Factors.DIRECT)) );
            fldK2.setValue( new Float( master.getUser().getFactors().getK2() ));

            fldS1.setText(""+Str.round(new Sugar(master.getUser().getS1())
                    .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
            fldS2.setText(""+Str.round(new Sugar(master.getUser().getS2())
                    .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
            fldOUV.setText(
                ""+Str.round(
                    new Sugar(master.getUser().getFactors().getK3())
                    .getSugar(master.getUser().isMmol(),
                    master.getUser().isPlasma()),master.getUser().isMmol()?2:1)
                    );
            calcMenu();
        }
    }
    private void removeAllEntries(){
        master.calcCoefsbyTime();
        for(int j=0;j<master.getMenu().size();j++){
            int id = ((ProductInMenu)master.getMenu().elementAt(j)).getId();
            if (id>=0){
                for(int i=0;i<master.getProds().size();i++){
                    if (id==((ProductInBase)master.getProds().elementAt(i)).getId() ){
                        ((ProductInBase)master.getProds().elementAt(i)).setSelected(false);
                        break;
                    }
                }
            }
        }
        master.getMenu().removeAllElements();

        rowPane.removeAll();
        rows.removeAllElements();

        rowPane.revalidate();
        //middle.revalidate();
        master.getUser().setS1( master.getUser().getTargetSugar() );
        master.getUser().setS2( master.getUser().getTargetSugar() );

        fldK1.setValue( new Float(master.getUser().getFactors().getK1(Factors.DIRECT)) );
        fldK2.setValue( new Float( master.getUser().getFactors().getK2() ));

        fldS1.setText(""+Str.round(new Sugar(master.getUser().getS1())
                .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
        fldS2.setText(""+Str.round(new Sugar(master.getUser().getS2())
                .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
        fldOUV.setText(
        ""+Str.round(
                new Sugar(master.getUser().getFactors().getK3())
                    .getSugar(master.getUser().isMmol(),
                    master.getUser().isPlasma()),master.getUser().isMmol()?2:1)
                    );

        calcMenu();
    }
    
    private void removeCurrEntry(){
        int pos = -1;
        for(int i=0;i<master.getMenu().size();i++){
            if ( ((ProdRow)rows.elementAt(i)).hasFocus() ){
                pos = i;
                break;
            }
        }
        if (pos>=0){
            int id = ((ProductInMenu)master.getMenu().elementAt(pos)).getId();
            if (id>=0){
                for(int i=0;i<master.getProds().size();i++){
                    if (id==((ProductInBase)master.getProds().elementAt(i)).getId() ){
                        ((ProductInBase)master.getProds().elementAt(i)).setSelected(false);
                        break;
                    }
                }
            }
            master.getMenu().removeElementAt(pos);

            rowPane.removeComponent((Container)rows.elementAt(pos));
            rows.removeElementAt(pos);

            rowPane.revalidate();
            //middle.revalidate();

            if (!rows.isEmpty()){
                if (pos==rows.size()){
                    pos--;
                }
                ((ProdRow)rows.elementAt(pos)).weight.requestFocus();
            }

            calcMenu();
        }
    }
    private ProductW calcMenu(){
        //парсим коэф-ты
        float k1 = ((Float)fldK1.getValue()).floatValue(); //Str.parseString(fldK1,2);
        float be = ((Float)fldBE.getValue()).floatValue();
        master.getUser().getFactors().setK1XE(k1, be, Factors.DIRECT);
        master.getUser().getFactors().setK2(((Float)fldK2.getValue()).floatValue());
        master.getUser().getFactors().setBEValue(be);
        Sugar ouv = new Sugar();
        ouv.setSugar(Str.parseString(fldOUV, 2), master.getUser().isMmol(),
                master.getUser().isPlasma());
        master.getUser().getFactors().setK3(ouv.getValue());

        ProductW pr = new ProductW();
        boolean fieldempty = false;
        for(int i=0;i<master.getMenu().size();i++){
            fieldempty = ( ((ProdRow)rows.elementAt(i)).weight.getText().length()==0 ) 
                    || fieldempty;
            //if ( ((ProdRow)rows.elementAt(i)).weight.getText().length()==0 ) fieldempty = true;
            float w = ((ProdRow)rows.elementAt(i)).getWeight();
            ProductW p = (ProductW)master.getMenu().elementAt(i);
            p.setWeight(w);
            String info;
            switch (master.getUser().getInfo()){
                case User.PFC_INFO: info = ""+Str.round(p.getAllProt(),1)+
                        "-" + Str.round(p.getAllFat(),1)+"-"+Str.round(p.getAllCarb(),1);
                break;
                case User.BE_INFO: info = ""+Str.round(p.getAllCarb()/
                        master.getUser().getFactors().getBE(Factors.DIRECT),1);
                break;
                case User.CALOR_INFO: info = ""+(int)Str.round(p.getCalories(),0);
                break;
                case User.DOSE_INFO:  info = ""+
                        Str.round(new Dose(
                                p,
                                master.getUser().getFactors(),
                                new DPS()).getWholeDose(),1);
                break;
                default: info = "===";
            }
            
            ((ProdRow)rows.elementAt(i)).info.setText(info);
            pr.plusProd( ((ProductW)master.getMenu().elementAt(i)) );
        }
        
        rowPane.repaint();
        Sugar s1 = new Sugar(master.getUser().getS1());
        //s1.setSugar(Str.parseString(fldS1, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        //master.getUser().setS1(s1.getValue());
        Sugar s2 = new Sugar(master.getUser().getS2());
        //s2.setSugar(Str.parseString(fldS2, 1), master.getUser().isMmol(), master.getUser().isPlasma());
        //master.getUser().setS2(s2.getValue());
        DPS dps = new DPS(s1,s2,master.getUser().getFactors());

        Dose ds = new Dose(pr,master.getUser().getFactors(),dps);
        
        int round;
        if (master.getUser().getRound()>User.ROUND_05) round = 2;
        else round = 1;
        
        fldBD.setText(""+Str.round(ds.getCarbFastDose()+ds.getDPSDose(),round) );
        fldMD.setText(""+Str.round(ds.getCarbSlowDose()+ds.getSlowDose(),round));
        fldSUM.setText(""+Str.round(ds.getWholeDose(),round));
        switch (master.getUser().getInfo()){
            case User.PFC_INFO: fldInfo.setText(
                    ""+Str.round(pr.getAllProt(),1)+"-"+
                       Str.round(pr.getAllFat(),1)+"-"+
                       Str.round(pr.getAllCarb(),1));
                    break;
            case User.BE_INFO: fldInfo.setText(
                    ""+Str.round(pr.getAllCarb()/
                       master.getUser().getFactors().getBE(Factors.DIRECT),1));
                    break;
            case User.DOSE_INFO:
            case User.CALOR_INFO: fldInfo.setText(
                    ""+(int)Str.round(pr.getCalories(),0) );
                    break;
        }
        String name = getName();
        if (fieldempty){
            name += " *";
        }
        if (Math.abs(ds.getDPSDose())>0){
            name += " Д";
        }
        if (master.getUser().isTimeSense()){
            name += " t";
        }
        form.setTitle( name );
        return pr;
    }

    private AnimatedLabel createAnimatedLabel(){
        AnimatedLabel fld = new AnimatedLabel();
        fld.setText("===");
        fld.setTickerEnabled(true);
        fld.getStyle().setAlignment(TextField.CENTER);
        fld.getStyle().setBorder(Border.createLineBorder(1, 0xDBDBDB));
        return fld;
    }

    private Container createTop(){
        Container con = new Container();
        Label lblBD = new Label("Б");
        Label lblMD = new Label("М");
        Label lblSUM = new Label("С");

        Label lblBE = new Label("И");

        fldBD = createAnimatedLabel();
        fldMD = createAnimatedLabel();
        fldSUM = createAnimatedLabel();
        
        Button b = new Button("===");
        b.getStyle().setAlignment(Button.CENTER);
        b.setFocusable(false);
        b.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent ev){
                gotoProducts();
            }
        });
        fldInfo = b;
        
        
        GroupLayout layout = new GroupLayout(con);
        con.setLayout(layout);

        layout.setAutocreateGaps(true);

        layout.setHorizontalGroup(layout.createParallelGroup()
                .add(layout.createSequentialGroup()
                    .add(lblBD)
                    .add(fldBD, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(lblMD)
                    .add(fldMD, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(layout.createSequentialGroup()
                    .add(lblSUM)
                    .add(fldSUM, 50, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(lblBE)
                    .add(fldInfo, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    )
                );
        layout.setVerticalGroup(layout.createSequentialGroup()
                .add(layout.createParallelGroup()
                    .add(lblBD)
                    .add(fldBD)
                    .add(lblMD)
                    .add(fldMD))
                .add(layout.createParallelGroup()
                    .add(lblSUM)
                    .add(fldSUM)
                    .add(lblBE)
                    .add(fldInfo))
                );
        con.getStyle().setBorder(Border.createLineBorder(1));//.createBevelRaised());
        return con;
    }
    private void gotoProducts(){
        calcMenu();
        master.showForm(DCJmobile.PRODUCTS,false);
    }
    private void replaceK2S(){
        calcMenu();
        middle.replace(coefPane, ouvPane, null);
        middle.revalidate();
    }
    private void replaceS2K(){
        calcMenu();
        middle.replace(ouvPane, coefPane, null);
        middle.revalidate();
    }
    private Button ladderOUV;
    
    private Container createOUVPane(){
        Container con = new Container();
        Label lblS1 = new Label("С1");
        fldS1 = new TextField();
        fldS1.setInputModeOrder(new String[]{"1+2"});
        fldS1.setInputMode("1+2");
        fldS1.setConstraint(TextField.DECIMAL);
        fldS1.setText(""+Str.round(new Sugar(master.getUser().getS1())
                .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));
        
        Label lblS2 = new Label("С2");
        fldS2 = new TextField();
        fldS2.setInputModeOrder(new String[]{"1+2"});
        fldS2.setInputMode("1+2");
        fldS2.setConstraint(TextField.DECIMAL);
        fldS2.setText(""+Str.round(new Sugar(master.getUser().getS2())
                .getSugar(master.getUser().isMmol(), master.getUser().isPlasma()),1));

        /*DataChangedListener dtLs = new DataChangedListener(){
            public void dataChanged(int type, int index){
                fldSugarsHaveChanged = true;
            }
        };*/
        //fldS1.addDataChangeListener(dtLs);
        //fldS2.addDataChangeListener(dtLs);

        Label lblOUV = new Label("ЦЕИ");
        fldOUV = new TextField();
        fldOUV.setInputModeOrder(new String[]{"1+2"});
        fldOUV.setInputMode("1+2");
        fldOUV.setConstraint(TextField.DECIMAL);
        fldOUV.setText(""+Str.round(
                new Sugar(master.getUser().getFactors().getK3())
                    .getSugar(master.getUser().isMmol(),
                    master.getUser().isPlasma()),master.getUser().isMmol()?2:1));

        /*fldS1.addActionListener(menuCalculator);
        fldS2.addActionListener(menuCalculator);
        fldOUV.addActionListener(menuCalculator);*/

        VirtualKeyboard.bindVirtualKeyboard(fldS1, vkS);
        VirtualKeyboard.bindVirtualKeyboard(fldS2, vkS);
        VirtualKeyboard.bindVirtualKeyboard(fldOUV, vkCoef);
        VirtualKeyboard.setCommitOnDispose(fldS1, true);
        VirtualKeyboard.setCommitOnDispose(fldS2, true);
        VirtualKeyboard.setCommitOnDispose(fldOUV, true);
        
        GroupLayout layout = new GroupLayout(con);
        con.setLayout(layout);

        GroupLayout.SequentialGroup horiz = layout.createSequentialGroup();
        GroupLayout.ParallelGroup vert = layout.createParallelGroup();

        ladderOUV = new Button("<<");//ladderOUV - потому что в обычной версии эта кнопка нажимается решеткой #
        try{
            ladderOUV.setIcon(Image.createImage("/images/left.png"));
        }catch(Exception ex){}
        finally{
            ladderOUV.setText(null);
        }
        ladderOUV.setPreferredW(Display.getInstance().getDisplayWidth()*12/100);
        ladderOUV.getStyle().setAlignment(Button.CENTER);
        ladderOUV.setFocusable(false);
        ladderOUV.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent ev){
                replaceS2K();
            }
        });
        //horiz= horiz.add(ladderOUV);
        //vert = vert.add(ladderOUV, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE);

        layout.setAutocreateGaps(true);
        

        horiz = horiz.add(layout.createParallelGroup()
                    .add(layout.createSequentialGroup()
                        .add(lblS1)
                        .add(1)
                        .add(fldS1, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(3)
                        .add(lblS2)
                        .add(1)
                        .add(fldS2, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(lblOUV)
                        .add(2)
                        .add(fldOUV, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        ));

       vert = vert.add(layout.createSequentialGroup()
                    .add(layout.createParallelGroup()
                        .add(lblS1)
                        .add(fldS1)
                        .add(lblS2)
                        .add(fldS2))
                    .add(layout.createParallelGroup()
                        .add(lblOUV)
                        .add(fldOUV)
                        ));

        layout.setHorizontalGroup(horiz);

        layout.setVerticalGroup(vert);

        Container res = new Container(new BorderLayout());
        
        res.addComponent(BorderLayout.CENTER, con);
        res.addComponent(BorderLayout.WEST, ladderOUV);
        
        return res;
    }
    private Button ladderCoef;
    
    private Container createCoefPane(){
        Container con = new Container();
        Label lblK1 = new Label("k1");
        fldK1 = new MaskTextField("#.##");
        FloatValidator fl = new FloatValidator();
        fldK1.setValidator(fl);

        Label lblK2 = new Label("k2");
        fldK2 = new MaskTextField("#.##");
        fldK2.setValidator(fl);
        

        Label lblBE = new Label("ХЕ");
        fldBE = new MaskTextField("##.#");
        fldBE.setValidator(fl);
        
        VirtualKeyboard.bindVirtualKeyboard(fldK1, vkCoef);
        VirtualKeyboard.bindVirtualKeyboard(fldK2, vkCoef);
        VirtualKeyboard.bindVirtualKeyboard(fldBE, vkCoef);
        VirtualKeyboard.setCommitOnDispose(fldK1, true);
        VirtualKeyboard.setCommitOnDispose(fldK2, true);
        VirtualKeyboard.setCommitOnDispose(fldBE, true);
        

        /*fldK1.addActionListener(menuCalculator);
        fldK2.addActionListener(menuCalculator);
        fldBE.addActionListener(menuCalculator);*/

        GroupLayout layout = new GroupLayout(con);
        con.setLayout(layout);
        
        GroupLayout.SequentialGroup horiz = layout.createSequentialGroup()
                .add(layout.createParallelGroup()
                    .add(layout.createSequentialGroup()
                        .add(lblK1)
                        .add(1)
                        .add(fldK1, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(3)
                        .add(lblK2)
                        .add(1)
                        .add(fldK2, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup().add(lblBE)
                        .add(2)
                        .add(fldBE, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)));

        GroupLayout.ParallelGroup vert = layout.createParallelGroup()
                .add(layout.createSequentialGroup()
                    .add(layout.createParallelGroup()
                        .add(lblK1)
                        .add(fldK1)
                        .add(lblK2)
                        .add(fldK2))
                    .add(layout.createParallelGroup()
                        .add(lblBE)
                        .add(fldBE)));
        
        ladderCoef = new Button(">>");//ladderCoef - потому что в обычной версии эта кнопка нажимается решеткой #
        try{
            ladderCoef.setIcon(Image.createImage("/images/right.png"));
        }catch(Exception ex){}
        finally{
            ladderCoef.setText(null);
        }
        ladderCoef.setPreferredW(Display.getInstance().getDisplayWidth()*12/100);
        ladderCoef.getStyle().setAlignment(Button.CENTER);
        ladderCoef.setFocusable(false);
        ladderCoef.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent ev){
                replaceK2S();
            }
        });
        //horiz= horiz.add(ladderCoef);
        //vert = vert.add(ladderCoef, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE);

        layout.setAutocreateGaps(true);
        

        layout.setHorizontalGroup(horiz);

        layout.setVerticalGroup(vert);

        Container res = new Container(new BorderLayout());
        
        res.addComponent(BorderLayout.CENTER, con);
        res.addComponent(BorderLayout.EAST, ladderCoef);
        
        return res;
    }
    
    /**
     * Returns the text that should appear in the help command
     */
    protected String getHelp() {
        return "";
        /*return "В данном окне устанавливается вес продуктов, которые собираетесь съесть.\n" +
                "Можно вводить вес выражением, например, так 152+6*18\n" +
                "Из набранных в меню продуктов можно \"приготовить\" новый продукт, " +
                "программа рассчитает его характеристики, однако состав продуктов " +
                "в таком сложном продукте сохранен не будет.\n" +
                "Если в какое либо поле веса не введено значение, то вверху, рядом с " +
                "названием окна появляется *\n"+
                "Можно сохранить меню в дневник.\n" +
                "Можно запустить таймер, который выведет напоминание о дозе инсулина.\n" +
                "Что бы деактивировать таймер введите нулевое значение задержки.\n" +
                "Для быстрого перехода к продуктам нажмите *\n" +
                "После выхода из программы меню не удаляется.";*/
    }
    
    
    
    class ProdRow extends Container{
        AnimatedLabel name = new AnimatedLabel();
        TextField weight = new TextField(){
            public void keyReleased(int k){
                if (k == new Integer('*').intValue()){
                    gotoProducts();
                }
                else super.keyReleased(k);
            }
            public void longPointerPress(int x, int y){
                super.longPointerPress(x, y);
                //Тут показываем контекстное меню.
                if (cmenu.getCommandsSize()==0) return;
                //Container 
                cmenu.showContextMenu(name.getText());
            }
        };
        AnimatedLabel info = createAnimatedLabel();
        
        private ContextMenu cmenu; //Это в классе ПродРоу
        
        public ProdRow(ContextMenu cmenu){
            super();
            this.cmenu = cmenu;
            
            name.setTickerEnabled(true);
            info.setTickerEnabled(true);
            weight.setHint("вес г.");
            weight.setLabelForComponent(info);
            weight.addFocusListener(new FocusListener(){
                public void focusGained(Component c){
                    if (!info.isTickerRunning()) 
                        info.startTicker(UIManager.getInstance().getLookAndFeel().getTickerSpeed(), true);
                    info.resetPosition();
                    if (!name.isTickerRunning()) 
                        name.startTicker(UIManager.getInstance().getLookAndFeel().getTickerSpeed(), true);
                    name.resetPosition();
                }
                public void focusLost(Component c){
                    info.stopTicker();
                    name.stopTicker();
                }
            });
            
            weight.setInputModeOrder(new String[]{"1+2"});
            weight.setInputMode("1+2");
            //weight.addActionListener(menuCalculator);
            //weight.setConstraint(TextField.DECIMAL);//При вводе с тач скринов нет возможности
            //вводить множить, делить и скобки

            VirtualKeyboard.bindVirtualKeyboard(weight, vk);
            VirtualKeyboard.setCommitOnDispose(weight, true);
            
            
            GroupLayout layout = new GroupLayout(this);
            setLayout(layout);
            int w13 = Display.getInstance().getDisplayWidth()/3;
            int w23 = Display.getInstance().getDisplayWidth() - w13;
            layout.setHorizontalGroup(layout.createParallelGroup()
                    .add(name, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(weight, 0, w13, w13)
                        .add(info, 0, w23, w23)
                    )
                    );
            layout.setVerticalGroup(layout.createSequentialGroup()
                    .add(name)
                    .add(layout.createParallelGroup()
                        .add(weight)
                        .add(info)
                     ));
            
        }
        
        public float getWeight(){
            return Str.parseString(weight,0);
        }
        public void setWeight(float w){
            weight.setText(w>0?(""+(int)Str.round(w,0)):"");
        }
        public boolean hasFocus(){
            return weight.hasFocus();
        }
        
        
        /**public int getPreferredW(){
            
            return 0;
        }*/
    }

        
}
