/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.diacalc.mobile.components;

/**
 *
 * @author connie
 */
import com.sun.lwuit.*;
import com.sun.lwuit.animations.CommonTransitions;
import com.sun.lwuit.animations.Transition;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;
import com.sun.lwuit.layouts.BorderLayout;
import com.sun.lwuit.layouts.BoxLayout;
import java.util.Vector;

public class ContextMenu {
    private static Transition out = CommonTransitions.createFade(400);
    private static Transition in = CommonTransitions.createFade(250);
    
    private Vector contextCommands; //MenuCommands
    private Dialog dl = null;
    
    public ContextMenu(){
        contextCommands = new Vector();
    }
    
    
       public void addCommand(Command c, ActionListener l){
           contextCommands.addElement(new MenuCommand(c,l));
       }
       public int getCommandsSize(){
           return contextCommands.size();
       }
       public void removeCommand(Command c){
           removeCommand(getCommandInd(c));
       }
       public void removeCommand(int i){
           contextCommands.removeElementAt(i);
       }
       public int getCommandInd(Command c){
           for(int i=0;i<contextCommands.size();i++){
               if ( ((MenuCommand)(contextCommands.elementAt(i))).getCommand().equals(c) ){
                   return i;
               }
           }
           return -1;
       }
       public ActionListener getCommandListener(Command c){
           for(int i=0;i<contextCommands.size();i++){
               if ( ((MenuCommand)(contextCommands.elementAt(i))).getCommand().equals(c) ){
                   return ((MenuCommand)(contextCommands.elementAt(i))).getListener();
               }
           }
           return null;
       }
       
       public Command getCommand(int i){
           return ((MenuCommand)contextCommands.elementAt(i)).getCommand();
       }
      
      private ActionListener contextListener = new ActionListener(){
        public void actionPerformed(ActionEvent ae) {
            if (dl!=null) { dl.dispose(); dl = null; }
            getCommandListener(ae.getCommand())
                    .actionPerformed(new ActionEvent(ae.getCommand(),
                        ae.getComponent(),ae.getX(),ae.getY()));
        }
          
      };
      
      public void showContextMenu(final String title){
          if (contextCommands.isEmpty()) return;
          
          
          dl = new Dialog(title){
              private boolean flag = false;
              public void pointerReleased(int x, int y){
                super.pointerReleased(x, y);
                if (!flag){
                      flag = true;
                      dl.setDisposeWhenPointerOutOfBounds(true);
                }
             }
          };
          
          //dl.getTitleComponent().setUIID("TitleContextMenuDialog");
          //dl.getContentPane().setUIID("MenuDialog");
          
          Container container = new Container(new BoxLayout(BoxLayout.Y_AXIS));
          
          for (int i=0;i<contextCommands.size();i++){
              Button b = new Button(getCommand(i));
              b.addActionListener(contextListener);
              container.addComponent(b);
          }
          
          dl.addComponent(container);
          dl.setDisposeWhenPointerOutOfBounds(false);
          
          dl.setTransitionInAnimator(in);
          dl.setTransitionOutAnimator(out);
                
          Display.getInstance().vibrate(150);
          
          dl.showPacked(BorderLayout.CENTER, true);
      }
}
