/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */


package org.diacalc.mobile.maths;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */
public class User {
    public final static String DEFAULT_SERVER_PATH = "http://diacalc.org/dbwork/";
    public final static int ROUND_1 = 1;
    public final static int ROUND_05 = 2;
    public final static int ROUND_025 = 3;
    public final static int ROUND_010 = 4;
    public final static int ROUND_005 = 5;

    public final static int PFC_INFO = 0;
    public final static int BE_INFO = 1;
    public final static int CALOR_INFO = 2;
    public final static int DOSE_INFO = 3;

    private String login;
    private String pass;
    private String server;
    private Factors fcs;
    private int round;
    private int info;
    private boolean backGr;
    private long timerTime;//когда должно случиться
    private String message;

    private boolean mmol;
    private boolean plasma;
    private float s1,s2;//sugars to restore after timer
    private boolean timeSense;
    private float targetS,lowS,hiS;//sugars target, low level, hi level
    private int timeCorr,timeDiary;//коррекция времени в программе, корекция времени при экспорте дневника

    public User(String login,String pass,String server,Factors fcs,
            int round,int info,boolean backGr,long t,String msg,boolean plasma,boolean mmol,
            float s1,float s2,boolean timeSense,float target,float low,float hi,
            int timeCorr,int timeDiary){
        this.login = login;
        this.pass = pass;
        this.server = server;
        this.fcs = fcs;
        this.round = round;
        this.info = info;
        this.backGr = backGr;
        this.timerTime = t;
        message = msg;
        this.plasma = plasma;
        this.mmol = mmol;
        this.s1 = s1;
        this.s2 = s2;
        this.timeSense = timeSense;
        this.targetS = target;
        this.lowS = low;
        this.hiS = hi;
        this.timeCorr = timeCorr;
        this.timeDiary = timeDiary;
    }
    public User(){
        this.login = "";
        this.pass = "";
        this.server = DEFAULT_SERVER_PATH;
        this.fcs = new Factors();
        this.round = 1;
        this.info = 1;
        this.backGr = false;
        this.timerTime = 0;
        message = "";
        this.plasma = false;
        this.mmol = true;
        this.s1 = 5.6f;
        this.s2 = 5.6f;
        this.timeSense = false;
        this.targetS = 5.6f;
        this.lowS = 3.6f;
        this.hiS = 7.5f;
        this.timeCorr = 0;
        this.timeDiary = 0;
    }
    public void setTimeCorr(int v){
        timeCorr = v;
    }
    public void setTimeDiary(int v){
        timeDiary = v;
    }
    public int getTimeCorr(){
        return timeCorr;
    }
    public int getTimeDiary(){
        return timeDiary;
    }
    public void setTargetSugar(float v){
        targetS = v;
    }
    public void setLowSugar(float v){
        lowS = v;
    }
    public void setHiSugar(float v){
        hiS = v;
    }
    public float getTargetSugar(){
        return targetS;
    }
    public float getLowSugar(){
        return lowS;
    }
    public float getHiSugar(){
        return hiS;
    }
    public void setTimeSense(boolean v){
        timeSense = v;
    }
    public boolean isTimeSense(){
        return timeSense;
    }
    public void setS1(float v){
        s1 = v;
    }
    public void setS2(float v){
        s2 = v;
    }
    public float getS1(){
        return s1;
    }
    public float getS2(){
        return s2;
    }
    public void setPlasma(boolean v){
        plasma = v;
    }
    public void setMmol(boolean v){
        mmol = v;
    }
    public boolean isPlasma(){
        return plasma;
    }
    public boolean isMmol(){
        return mmol;
    }
    public String getMessage(){
        return message;
    }
    public void setMessage(String msg){
        message = msg;
    }
    public void setTimerTime(long v){
        timerTime = v;
    }
    public long getTimerTime(){
        return timerTime;
    }
    public void setBackGrSupported(boolean  v){
        backGr = v;
    }
    public boolean isBackGrSupported(){
        return backGr;
    }
    public void setRound(int v){
        round = v;
    }
    public int getRound(){
        return round;
    }
    public void setInfo(int v){
        info = v;
    }
    public int getInfo(){
        return info;
    }
    public void setLogin(String v){
        login = v;
    }
    public void setPass(String v){
        pass = v;
    }
    public void setServer(String v){
        server = v;
    }
    public void setFactors(Factors v){
        fcs = v;
    }

    public String getLogin(){
        return login;
    }
    public String getPass(){
        return pass;
    }
    public String getServer(){
        return server;
    }
    public Factors getFactors(){
        return fcs;
    }
}
